# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

#TODO: BR: perl(Test::Pod::No404s) when available

Name:		perl-Test-Kwalitee
Version:	1.28
Release:	1.%{__distinit}%{__distvers}
Summary:	Test the Kwalitee of a distribution before you release it
License:	GPL+ or Artistic
URL:		http://metacpan.org/module/Test::Kwalitee
Source0:	https://cpan.metacpan.org/modules/by-module/Test/Test-Kwalitee-%{version}.tar.gz
Patch0:		Test-Kwalitee-1.27-taint.patch
Patch3:		Test-Kwalitee-1.23-spelling.patch
BuildArch:	noarch
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module
BuildRequires:	perl(Cwd)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(Module::CPANTS::Analyse) >= 0.92
BuildRequires:	perl(parent)
BuildRequires:	perl(strict)
BuildRequires:	perl(Test::Builder) >= 0.88
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(CPAN::Meta::Check) >= 0.011
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(lib)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Test::Deep)
BuildRequires:	perl(Test::More) >= 0.96
BuildRequires:	perl(Test::Tester) >= 0.108
BuildRequires:	perl(Test::Warnings) >= 0.009
# Author/Release Tests
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(blib)
BuildRequires:	perl(Encode)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(if)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(Pod::Coverage::TrustPod)
BuildRequires:	perl(Pod::Wordlist::hanekomu)
BuildRequires:	perl(Test::CleanNamespaces) >= 0.15
BuildRequires:	perl(Test::CPAN::Changes)
BuildRequires:	perl(Test::CPAN::Meta)
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::MinimumVersion)
BuildRequires:	perl(Test::Mojibake)
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Portability::Files)
BuildRequires:	perl(Test::Spelling) >= 0.12, aspell-en
BuildRequires:	perl(Test::Version)
%endif
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
Kwalitee is an automatically-measurable gauge of how good your software
is. That's very different from quality, which a computer really can't
measure in a general sense (if you can, you've solved a hard problem in
computer science).

%prep
%setup -q -n Test-Kwalitee-%{version}

# Taint test fails mysteriously prior to Fedora 16
# https://github.com/karenetheridge/Test-Kwalitee/issues/10
%if 0%{?fedora} < 16 && 0%{?rhel} < 7
%patch0
%endif

# Words that should be in the dictionary but aren't
%patch3

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

# Author/Release tests
%if 0%{!?perl_bootstrap:1}
make test RELEASE_TESTING=1 TEST_FILES="$(echo $(find xt/ -name '*.t' | grep -Fv kwalitee_ok.t))"
%endif

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes CONTRIBUTING README
%{_bindir}/kwalitee-metrics
%{perl_vendorlib}/Test/
%{_mandir}/man1/kwalitee-metrics.1*
%{_mandir}/man3/Test::Kwalitee.3*

%changelog
* Mon Feb  4 2019 Paul Howarth <paul@city-fan.org> - 1.28-1
- Update to 1.28
  - Fix taint-mode tests to accomodate failures with Module::CPANTS::Analyse
    0.99 (insecure loading of a backend implementation)

* Mon Nov  6 2017 Paul Howarth <paul@city-fan.org> - 1.27-1
- Update to 1.27
  - Make taint test TODO when version.pm is not current (see CPAN RT#118087)
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Fri May 12 2017 Paul Howarth <paul@city-fan.org> - 1.26-1
- Update to 1.26
  - Bump Test::More prereq for (fully) working subtests
  - Properly detect the xt/ caller condition when running kwalitee_ok directly
    (CPAN RT#120554)
- Add workaround for taint test failing mysteriously prior to Fedora 16
  (https://github.com/karenetheridge/Test-Kwalitee/issues/10)
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Tue Feb 28 2017 Paul Howarth <paul@city-fan.org> - 1.25-1
- Update to 1.25
  - New test for compatibility in taint mode
  - Fix test to not rely on . in @INC

* Mon Jan  9 2017 Paul Howarth <paul@city-fan.org> - 1.23-2
- Can build on distributions as old as Fedora 9 now that we have
  Test::More ≥ 0.96 there

* Fri Oct 14 2016 Paul Howarth <paul@city-fan.org> - 1.23-1
- Update to 1.23
  - Update the list of metrics to the latest Module::CPANTS::Analyse
- Switch back to ExtUtils::MakeMaker flow
- Update patches as needed

* Sat Oct  1 2016 Paul Howarth <paul@city-fan.org> - 1.22-6
- BR: perl-generators where possible

* Sun Jun 28 2015 Paul Howarth <paul@city-fan.org> - 1.22-4
- Perl 5.22 rebuild

* Thu Sep  4 2014 Paul Howarth <paul@city-fan.org> - 1.22-1
- Update to 1.22
  - Running the tests via the import method directly has been deprecated; the
    new kwalitee_ok() function is added to provide a more sane and logical
    layout to your tests
  - Document metrics added in Module::CPANTS::Analyse 0.93_03
- Update patches as needed

* Mon Jul 21 2014 Paul Howarth <paul@city-fan.org> - 1.19-1
- Update to 1.19
  - kwalitee-metrics script now includes the module version as well as the
    name, for each metric provided
  - Remove test that is rendered invalid with upcoming changes to Test::Builder
    (1.005+)
  - Document new metrics added in Module::CPANTS::Analyse 0.93_01
- Use %%license where possible
- Update patches as needed

* Wed Jan 22 2014 Paul Howarth <paul@city-fan.org> - 1.18-1
- Update to 1.18
  - Updated list of available metrics
- Bump perl(Module::Build::Tiny) version requirement to 0.034
- BR: perl(Test::Portability::Files)
- Package README.md
- Update patches as needed

* Mon Oct 21 2013 Paul Howarth <paul@city-fan.org> - 1.17-1
- Update to 1.17
  - Now printing even more diagnostics on error (as much as we have available)
- Package new CONTRIBUTING file
- Update buildreqs as needed
- Update patches as needed

* Wed Sep 25 2013 Paul Howarth <paul@city-fan.org> - 1.15-1
- Update to 1.15
  - Re-release with fixed compile test
- Bump perl(Module::Build::Tiny) version requirement to 0.027
- Update buildreqs for tests
  - Drop perl(CPAN::Meta::Check)
  - Add perl(ExtUtils::MakeMaker), perl(File::Spec::Functions),
    perl(List::Util) and perl(Test::Mojibake)
  - Bump perl(Test::CheckDeps) version requirement to 0.007
- Update patches as needed

* Wed Sep  4 2013 Paul Howarth <paul@city-fan.org> - 1.14-1
- Update to 1.14
  - Updated inaccurate test prereq
- Update buildreqs for tests
  - Drop perl(Capture::Tiny) and perl(Test::Script)
  - Require at least version 0.005 of perl(Test::Warnings)
  - BR: perl(File::Spec), perl(IO::Handle) and perl(IPC::Open3)
- Update patches as needed

* Thu Aug 22 2013 Paul Howarth <paul@city-fan.org> - 1.13-1
- Update to 1.13
  - Added missing abstract for kwalitee-metrics script
  - No longer issuing a warning if the test is running from xt/ (see v1.10)
- Add patch to support building with Test::More < 0.96
- BR:/R: perl(Dist::CheckConflicts) ≥ 0.02
- Bump perl(Module::Build::Tiny) version requirement to 0.026
- BR: perl(CPAN::Meta::Check) ≥ 0.007 and perl(Test::CPAN::Changes) for the
  test suite

* Fri Aug  2 2013 Paul Howarth <paul@city-fan.org> - 1.12-1
- Update to 1.12
  - Adjusted tests to compensate for changes made in Module::CPANTS::Analyse
    0.88/0.90_01
- Drop BR: perl(Test::CPAN::Changes), test dropped upstream
- Update patches as needed

* Tue Jul 30 2013 Paul Howarth <paul@city-fan.org> - 1.11-1
- Update to 1.11
  - Install the kwalitee-metrics script

* Mon Jul 29 2013 Paul Howarth <paul@city-fan.org> - 1.10-1
- Update to 1.10
  - We now issue a warning if running when neither AUTHOR_TESTING or
    RELEASE_TESTING environment variables are set
  - Test level adjusted, so location of failing test is correct
  - Include a script to dump all metrics ("kwalitee-metrics")
- BR: perl(Test::Script) ≥ 1.05 and perl(Test::Warnings) where possible
- Update patches as needed

* Thu Jul 25 2013 Paul Howarth <paul@city-fan.org> - 1.09-2
- Perl 5.18 rebuild

* Thu Jul 18 2013 Paul Howarth <paul@city-fan.org> - 1.09-1
- Update to 1.09
  - The has_test_pod, has_test_pod_coverage tests have been removed - they are
    classified as 'extra', and have been largely considered to be a bad idea
    anyway (these are often shipped as, and ought to be, in xt/)
  - The extractable test has been removed, as it does nothing in dists before
    there is a tarball present
  - New tests have been added: all standard kwalitee tests that can be run on a
    bare distribution without a tarball
- BR: perl(Capture::Tiny) for test suite
- Update patches as needed

* Tue Jul 16 2013 Paul Howarth <paul@city-fan.org> - 1.08-1
- Update to 1.08
  - Documentation fixed to reflect which indicators are actually available
  - Metric names are no longer hardcoded, so Module::CPANTS::Analyse has more
    freedom to add and remove metrics
- Update patches as needed

* Sat Jun 29 2013 Paul Howarth <paul@city-fan.org> - 1.07-1
- Update to 1.07
  - Now the indicators are run in the exact order they are returned from
    Module::CPANTS::Kwalitee::*, as some tests depend on the results of
    earlier tests
  - Synopsis updated to recommend a better way to run this module, ensuring
    that it is not run by cpantesters or at installation time
  - We no longer create a function in our namespace for every metric we are
    going to test; this should not break anyone, as these subs were never
    documented as part of the public API
  - Switch to Module::Build::Tiny flow
- BR: perl(namespace::clean) for module
- BR: perl(Test::CleanNamespaces) and perl(Test::Vars) for extra tests
- Bump version requirement for perl(Test::CheckDeps) to 0.006
- Update patches as needed
- Drop %%defattr, redundant since rpm 4.4

* Tue May 14 2013 Paul Howarth <paul@city-fan.org> - 1.06-1
- Update to 1.06
  - Restore previous behaviour of plan()ing in import, to unbreak some dists
    that didn't follow the docs (which in this case is ok since it's a horrible
    idea for a Test module to plan itself anyway) (v1.05)
  - More diagnostic data is printed when a test fails (CPAN RT#85107)

* Mon May 13 2013 Paul Howarth <paul@city-fan.org> - 1.05-1
- Update to 1.05
  - More rigorous testing of output; in order to make this possible, now we do
    END { done_testing } instead of planning a test count
- Now requires Test::More ≥ 0.88 for core functionality, so drop patches for
  building with older versions
- Update other patches as needed
- Bump perl(Test::Builder) version requirement to 0.88
- BR: perl(Test::Deep) and perl(Test::Tester) for the test suite

* Sun Apr 28 2013 Paul Howarth <paul@city-fan.org> - 1.04-1
- Update to 1.04
  - Re-release with bumped developer prereqs to depend on a higher version of
    Test::More for t/00-compile.t and t/00-check-deps.t (CPAN RT#84900)
- Update patches as needed

* Sat Apr 27 2013 Paul Howarth <paul@city-fan.org> - 1.03-1
- Update to 1.03
  - Fixed documentation to refer to the proper names of Kwalitee tests
    (CPAN RT#24506)
  - Cleaned up partially-botched distribution metadata and README
- Classify buildreqs by usage
- Add buildreqs for new tests
- Explicitly run extra tests unless bootstrapping
- Add several patches to support building with old versions of Test::More

* Mon Apr  1 2013 Paul Howarth <paul@city-fan.org> - 1.02-1
- Update to 1.02
  - No operational changes - re-releasing under new management via github and
    Dist::Zilla
- This release by ETHER -> update source URL
- Update upstream URLs to MetaCPAN
- Switch to ExtUtils::MakeMaker flow
- Package upstream's new LICENSE file
- Add patch to support building with ExtUtils::MakeMaker < 6.30

* Wed Jul 11 2012 Paul Howarth <paul@city-fan.org> - 1.01-13
- BR: perl(Test::More)
- Don't BR: perl(strict), perl(vars) or perl(warnings) - not dual-lived

* Thu Mar  8 2012 Paul Howarth <paul@city-fan.org> - 1.01-12
- BR: perl(Cwd), perl(strict), perl(Test::Builder), perl(vars), perl(warnings)
- Don't need to remove empty directories from buildroot
- Drop support for distributions prior to FC-3:
  - Don't need to run tests with LC_ALL=C
  - Don't need to define %%{perl_vendorlib}

* Wed Jun 29 2011 Paul Howarth <paul@city-fan.org> - 1.01-10
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Mar 23 2011 Paul Howarth <paul@city-fan.org> - 1.01-9
- Run tests with LC_ALL=C for Perl 5.8.0 compatibility
- Nobody else likes macros for commands

* Fri Mar 18 2011 Paul Howarth <paul@city-fan.org> - 1.01-8
- Import from Fedora

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.01-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Dec 22 2010 Marcela Maslanova <mmaslano@redhat.com> - 1.01-6
- Rebuild to fix problems with vendorarch/lib (#661697)

* Thu May 06 2010 Marcela Maslanova <mmaslano@redhat.com> - 1.01-5
- Mass rebuild with perl-5.12.0

* Fri Dec  4 2009 Stepan Kasal <skasal@redhat.com> - 1.01-4
- Rebuild against perl 5.10.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.01-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.01-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Feb 14 2009 Allisson Azevedo <allisson@gmail.com> - 1.01-1
- Initial rpm release
